'use strict';

/* App Module */

var app = angular.module('app', [
    'ui.bootstrap',
    'ui.router',
    'LocalStorageModule',
    'dialogs.main',
    'ngSanitize',
    'luticateUtils',
    'luticateAuth',
    'appSdk'
]);

app.config(['$stateProvider', '$urlRouterProvider', '$httpProvider', '$locationProvider',
    function($stateProvider, $urlRouterProvider, $httpProvider, $locationProvider) {

        //$locationProvider.html5Mode(true);

        $stateProvider.state('login',{
            url:'/',
            templateUrl:'views/login.html',
            controller:'LoginController',
            resolve:{}
        });

        $stateProvider.state('home',{
            url:'/home',
            templateUrl:'views/home.html',
            controller:'HomeController',
            revolve:{}
        });

        $urlRouterProvider.otherwise('/');

        $httpProvider.interceptors.push(['luticateAuthCache', '$injector', '$q',
            function (luticateAuthCache, $injector, $q) {
                return {
                    'request': function (config) {
                        var token = luticateAuthCache.getToken();

                        if (token != null)
                            config.headers['X-Authorization'] = token;

                        return config;
                    },
                    'responseError': function(rejection) {
                        return $q.reject(rejection);
                    }
                };
            }]);

    }])
    .run(['$rootScope', '$state',function ($rootScope, $state) {
        $rootScope.$on('$stateChangeError', function (e, curr, prev) {
            $state.go('login');
        });
    }]);